local function Coords(north, west, south, east)
    -- Return a function for converting (longitude, lattitude) into (x, y)
    return function(lattitude, longitude)
        local x = 800 * (longitude - west) / (east - west);
        local y = 600 * (lattitude - north) / (south - north);
        return { x, y };
    end
end

mapdata={};

ShireCoords = Coords(-22.9, -80.9, -38.8, -59.8);
mapdata["Shire"]={};
mapdata["ShireS"]={};
mapdata["ShireN"]={};
mapdata["Shirec"] = ShireCoords;
mapdata["ShireN"]["23.7S 67.8W"] = ShireCoords(-23.7, -67.8);
mapdata["Shire"]["34.3S 64.4W"] = ShireCoords(-34.3, -64.4);
mapdata["Shire"]["33.3S 67.8W"] = ShireCoords(-33.3, -67.8);
mapdata["Shire"]["34.0S 70.0W"] = ShireCoords(-34.0, -70.0);
mapdata["ShireS"]["29.4S 71.4W"] = ShireCoords(-29.4, -71.4);
mapdata["ShireS"]["33.4S 75.5W"] = ShireCoords(-33.4, -75.5);
mapdata["ShireS"]["31.4S 62.9W"] = ShireCoords(-31.4, -62.9);


EredLuinCoords = Coords(-12.6, -113.0, -32.4, -86.6);
mapdata["Ered Luin"]={};
mapdata["Ered LuinS"]={};
mapdata["Ered LuinN"]={};
mapdata["Ered Luinc"] = EredLuinCoords;
mapdata["Ered LuinN"]["24.9S 91.9W"] = EredLuinCoords(-24.9, -91.9);
mapdata["Ered Luin"]["21.6S 94.2W"] = EredLuinCoords(-21.6, -94.2);
mapdata["Ered LuinS"]["13.9S 103.3W"] = EredLuinCoords(-13.9, -103.3);
mapdata["Ered LuinS"]["24.4S 93.2W"] = EredLuinCoords(-24.4, -93.2);
mapdata["Ered LuinS"]["21.6S 92.5W"] = EredLuinCoords(-21.6, -92.5);


BreeCoords = Coords(-17.7, -65.6, -38.9, -37.4);
mapdata["Bree-Land"]={};
mapdata["Bree-LandS"]={};
mapdata["Bree-LandN"]={};
mapdata["Bree-Landc"] = BreeCoords;
mapdata["Bree-LandN"]["19.9S 41.9W"] = BreeCoords(-19.9, -41.9);
mapdata["Bree-Land"]["31.9S 62.4W"] = BreeCoords(-31.9, -62.4);
mapdata["Bree-Land"]["30.2S 52.0W"] = BreeCoords(-30.2, -52.0);
mapdata["Bree-Land"]["32.5S 43.5W"] = BreeCoords(-32.5, -43.5);
mapdata["Bree-Land"]["22.3S 52.1W"] = BreeCoords(-22.3, -52.1);
mapdata["Bree-Land"]["21.6S 42.6W"] = BreeCoords(-21.6, -42.6);
mapdata["Bree-LandS"]["29.8S 51.2W"] = BreeCoords(-29.8, -51.2);
mapdata["Bree-LandS"]["32.7S 57.1W"] = BreeCoords(-32.7, -57.1);
mapdata["Bree-LandS"]["33.9S 55.8W"] = BreeCoords(-33.9, -55.8);


LoneLandsCoords = Coords(-26.2, -44.3, -43.7, -20.9);
mapdata["Lone-Lands"]={};
mapdata["Lone-LandsS"]={};
mapdata["Lone-LandsN"]={};
mapdata["Lone-Landsc"] = LoneLandsCoords;
mapdata["Lone-LandsN"]["19.9S 41.9W"] = LoneLandsCoords(-19.9, -41.9);
mapdata["Lone-Lands"]["31.2S 30.0W"] = LoneLandsCoords(-31.2, -30.0);
mapdata["Lone-LandsS"]["31.3S 37.1W"] = LoneLandsCoords(-31.3, -37.1);
mapdata["Lone-LandsS"]["33.6S 23.0W"] = LoneLandsCoords(-33.6, -23.0);
mapdata["Lone-LandsS"]["34.1S 40.6W"] = LoneLandsCoords(-34.1, -40.6);


TrollshawsCoords = Coords(-20.8, -26.3, -41.3, 0.9);
mapdata["Trollshaws"]={};
mapdata["TrollshawsS"]={};
mapdata["TrollshawsN"]={};
mapdata["Trollshawsc"] = TrollshawsCoords;
mapdata["TrollshawsN"]["33.1S 6.0W"] = TrollshawsCoords(-33.1, -6.0);
mapdata["Trollshaws"]["29.2S 6.6W"] = TrollshawsCoords(-29.2, -6.6);
mapdata["TrollshawsS"]["30.0S 4.6W"] = TrollshawsCoords(-30.0, -4.6);
mapdata["TrollshawsS"]["17.7S 1.7W"] = TrollshawsCoords(-17.7, -1.7);
mapdata["TrollshawsS"]["24.7S 4.1W"] = TrollshawsCoords(-24.7, -4.1);


AngmarCoords = Coords(14.6, -42.8, -7.4, -13.3);
mapdata["Angmar"]={};
mapdata["AngmarS"]={};
mapdata["AngmarN"]={};
mapdata["Angmarc"] = AngmarCoords;
mapdata["AngmarN"]["2.2N 34.2W"] = AngmarCoords(2.2, -34.2);
mapdata["Angmar"]["2.2N 34.2W"] = AngmarCoords(14.6, -42.8);
mapdata["AngmarS"]["0.1S 40.2W"] = AngmarCoords(-0.1, -40.2);
mapdata["AngmarS"]["2.9S 39.0W"] = AngmarCoords(-2.9, -39.0);
mapdata["AngmarS"]["1.8S 33.2W"] = AngmarCoords(-1.8, -33.2);


EvendimCoords = Coords(-1.6, -82.6, -24.4, -52.3);
mapdata["Evendim"]={};
mapdata["EvendimS"]={};
mapdata["EvendimN"]={};
mapdata["Evendimc"]= EvendimCoords;
mapdata["EvendimN"]["23.7S 67.8W"] = EvendimCoords(-23.7, -67.8);
mapdata["Evendim"]["6.1S 72.0W"] = EvendimCoords(-6.1, -72.0);
mapdata["EvendimS"]["17.4S 68.8W"] = EvendimCoords(-17.4, -68.8);
mapdata["EvendimS"]["7.9S 63.9W"] = EvendimCoords(-7.9, -63.9);
mapdata["EvendimS"]["13.7S 75.9W"] = EvendimCoords(-13.7, -75.9);


ForochelCoords = Coords(25.0, -92.5, -5.5, -52.4);
mapdata["Forochel"]={};
mapdata["ForochelS"]={};
mapdata["ForochelN"]={};
mapdata["Forochelc"] = ForochelCoords;
mapdata["ForochelS"][""] = ForochelCoords(0, 0);
mapdata["ForochelN"][""] = ForochelCoords(0, 0);
mapdata["Forochel"][""] = ForochelCoords(0, 0);



MistyCoords = Coords(-14.8, -12.5, -32.9, 12.3);
mapdata["Misty Mountains"]={};
mapdata["Misty MountainsS"]={};
mapdata["Misty MountainsN"]={};
mapdata["Misty Mountainsc"] = MistyCoords;
mapdata["Misty MountainsN"]["33.1S 6.0W"] = MistyCoords(-33.1, -6.0);
mapdata["Misty Mountains"]["29.2S 6.6W"] = MistyCoords(-29.2, -6.6);
mapdata["Misty MountainsS"]["30.0S 4.6W"] = MistyCoords(-30.0, -4.6);
mapdata["Misty MountainsS"]["17.7S 1.7W"] = MistyCoords(-17.7, -1.7);
mapdata["Misty MountainsS"]["24.7S 4.1W"] = MistyCoords(-24.7, -4.1);


NorthDownsCoords = Coords(-1.3, -60.4, -22.5, -32.2);
mapdata["North Downs"]={};
mapdata["North DownsS"]={};
mapdata["North DownsN"]={};
mapdata["North Downsc"] = NorthDownsCoords;
mapdata["North DownsN"]["19.9S 41.9W"] = NorthDownsCoords(-19.9, -41.9);
mapdata["North DownsS"]["6.0S 55.3W"] = NorthDownsCoords(-6.0, -55.3);
mapdata["North DownsS"]["9.6S 41.4W"] = NorthDownsCoords(-9.6, -41.4);
mapdata["North DownsS"]["10.2S 45.7W"] = NorthDownsCoords(-10.2, -45.7);
mapdata["North Downs"]["11.2S 44.3W"] = NorthDownsCoords(-11.2, -44.3);



WGondorCoords = Coords(-50.3, -90.3, -83.0, -47.3);
mapdata["Western Gondor"]={};
mapdata["Western GondorS"]={};
mapdata["Western GondorN"]={};
mapdata["Western Gondorc"] = WGondorCoords;
mapdata["Western GondorS"][""] = WGondorCoords(0, 0);
mapdata["Western GondorN"][""] = WGondorCoords(0, 0);
mapdata["Western Gondor"][""] = WGondorCoords(0, 0);



CGondorCoords = Coords(-66.6, -59.4, -91.1, -26.9);
mapdata["Central Gondor"]={};
mapdata["Central GondorS"]={};
mapdata["Central GondorN"]={};
mapdata["Central Gondorc"] = CGondorCoords;
mapdata["Central GondorS"]["0, 0"] = CGondorCoords(0, 0);
mapdata["Central GondorN"]["0, 0"] = CGondorCoords(0, 0);
mapdata["Central Gondor"]["0, 0"] = CGondorCoords(0, 0);


EGondorCoords = Coords(-60.6, -26.5, -80.1, -0.1);
mapdata["Eastern Gondor"]={};
mapdata["Eastern GondorS"]={};
mapdata["Eastern GondorN"]={};
mapdata["Eastern Gondorc"] = EGondorCoords;
mapdata["Eastern GondorS"]["0, 0"] = EGondorCoords(0, 0);
mapdata["Eastern GondorN"]["0, 0"] = EGondorCoords(0, 0);
mapdata["Eastern Gondor"]["0, 0"] = EGondorCoords(0, 0);



WastesCoords = Coords(-26.1, -17.0, -41.5, 3.5);
mapdata["The Wastes"]={};
mapdata["The WastesS"]={};
mapdata["The WastesN"]={};
mapdata["The Wastesc"] = WastesCoords;
mapdata["The WastesS"]["0, 0"] = WastesCoords(0, 0);
mapdata["The WastesN"]["0, 0"] = WastesCoords(0, 0);
mapdata["The Wastes"]["0, 0"] = WastesCoords(0, 0);



GorgorothCoords = Coords(-35.3, -6.0, -69.4, 39.5);
mapdata["Gorgoroth"]={};
mapdata["GorgorothS"]={};
mapdata["GorgorothN"]={};
mapdata["Gorgorothc"] = GorgorothCoords;
mapdata["GorgorothS"]["0, 0"] = GorgorothCoords(0, 0);
mapdata["GorgorothN"]["0, 0"] = GorgorothCoords(0, 0);
mapdata["Gorgoroth"]["0, 0"] = GorgorothCoords(0, 0);



NMirkwoodCoords = Coords(37.4, -56.6, 5.3, -13.8);
mapdata["Northern Mirkwood"]={};
mapdata["Northern MirkwoodS"]={};
mapdata["Northern MirkwoodN"]={};
mapdata["Northern Mirkwoodc"] = NMirkwoodCoords;
mapdata["Northern MirkwoodS"]["0, 0"] = NMirkwoodCoords(0, 0);
mapdata["Northern MirkwoodN"]["0, 0"] = NMirkwoodCoords(0, 0);
mapdata["Northern Mirkwood"]["0, 0"] = NMirkwoodCoords(0, 0);


